{% extends 'base.html.twig' %}

{% block title %}Test ajax Axios{% endblock %}

{% block body %}
    <div class="container">
        <h1 class="my-3">Nos articles</h1>
        {% if not is_granted('ROLE_USER') %}
            <a href="/login" class="my-2 btn btn-success">Connexion</a>
        {% else %}
            <a href="/logout" class="my-2 btn btn-danger">Déconnexion</a>
        {% endif %}
        <div class="row">
            {% for post in posts %}
                <div class="col-3 mb-3">
                    <div class="border border-dark rounded p-2">
                        <h3>{{post.title}}</h3>
                        <p>{{post.introduction}}</p>
                        <a href="#" class="btn btn-primary">Lire la suite</a>
                        <a href="{{ path('post_like', {'id': post.id}) }}" class="btn btn-link js-like">
                        {% if app.user and post.isLikedByUser(app.user) %}
                        <i class="fas fa-thumbs-up" aria-hidden="true"></i>
                        {% else %}
                        <i class="far fa-thumbs-up" aria-hidden="true"></i>
                        {% endif %}
                        <span class="js-likes">{{post.likes | length}}</span>
                        <span class="js-label">J'aime</span>
                        </a>
                    </div>                    
                </div>
            {% endfor %}
        </div>
    </div>
{% block javascripts %}
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    <script>
        function onClikBtnLike(event){
            event.preventDefault();
            const url = this.href;
            const spanCount = this.querySelector('span.js-likes');
            const icone = this.querySelector('i');
            
            axios.get(url).then(function(response){
                spanCount.textContent = response.data.likes;

                if(icone.classList.contains('fas')){
                    icone.classList.replace('fas', 'far');
                }else{
                     icone.classList.replace('far', 'fas');
                }
            }).catch(function(error){
                if(error.response.status === 403){
                    window.alert("Vous devez être connecté pour liker un article")
                }else{
                    window.alert("une erreur c'est produite réessayez ultérieurement")
                }
            });
        }
        document.querySelectorAll('a.js-like').forEach(function(link){
            link.addEventListener('click', onClikBtnLike);
        })
    </script>
{% endblock %}
{% endblock %}